/*  Calling Subroutines - The Format and Explanations...

    Started: 02/08/89           Myke Predko
    Updated: 93.04.16
    Updated: 96.02.15 - Got Rid of "STRINGLEN" and Used "strlen" in
                        "C" Libraries.  MAP
             97.01.03 - Added "CLI()" & "STI()" Instructions

                                                                   */

  int GETKEY();                 /*  Return Keyboard Key Character  */
  int GETKEYSTAT();             /*  Return Key or Zero (no Key)    */
  int GETROW();                 /*  Return the Cursor Row          */
  int GETCOL();                 /*  Return the Cursor Column       */
  GOTOXY( int Row, int Column );/*  Move Cursor to Specified loc'n */
  SCREENCLEAR();                /*  Clear the Screen               */
  long int GETMEMAVAIL();       /*  Return Amount of RAM Available */
  void far *GETMEM( long int MemSize );  /*  Allocate Specified RAM*/
           FREEMEM( void far *FreePtr );  /*  Free Allocated RAM   */
           RESIZE( void far *ResizePtr, long int MemSize );
                                /*  Resize Specified Memory Block  */
  int      GETSEG( void far * Ptr );  /*  Return Pointer Values    */
  int      GETOFF( void far * Ptr );
           DECASCII( char far *StringPtr, int Value );
                                /*  Int to ASCII                   */
       int STRSUBCMP( char far *SuperStr, char far *SubString );
                                /*  like C "strcmp" Function       */
       int STRSUBCMPI( char far *SuperStr, char far *SubString );
                                /*  like C "STRSUBCMP", but Case   */
                                /*   Insensitive                   */
  long int MINIMUML( long int Value1, long int Value2 );
                                /*  Return Minimum Value           */
           BREAKPOINT();        /*  Simply Execute a X'CC' Instruct*/
  CLI();                        /*  Execute a "CLI" Instruction    */
  STI();                        /*  Execute an "STI" Instruction   */
       int STRINGSEARCH( char far *SuperStr, char far *SubString );
                                /*  Search Super for Sub           */
                                /*  If Found, Return Offset        */
                                /*  If NOT Found, Return -1        */
           BLOCKMOVE( char far *Dest, char far *Source, int Count );
                                /*  Move the String...             */
  long int SHORTTOLONG( int i );/*  Convert from 16 Bit to 32 Bit  */
           HEXBYTE( char far * String, long int Value );
                                /*  Convert Integer to 2 byte Strg */
       int ASCIIINT( char far * String );
                                /*  Return First Two Bytes as INT  */
