// tic tac toeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "tic tac toe.h"
#include "tic tac toeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTictactoeDlg dialog

CTictactoeDlg::CTictactoeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTictactoeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTictactoeDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTictactoeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTictactoeDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTictactoeDlg, CDialog)
	//{{AFX_MSG_MAP(CTictactoeDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
	ON_BN_CLICKED(IDC_BUTTON9, OnButton9)
	ON_BN_CLICKED(IDC_NEWGAME, OnNewgame)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTictactoeDlg message handlers

BOOL CTictactoeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	for ( int i = 0; i < 9; i++ )
		buttonState[i] = 0;

	VERIFY( button[0].AutoLoad(IDC_BUTTON1, this));  buttonState[0] = 2;
	VERIFY( button[1].AutoLoad(IDC_BUTTON2, this));
	VERIFY( button[2].AutoLoad(IDC_BUTTON3, this));
	VERIFY( button[3].AutoLoad(IDC_BUTTON4, this));
	VERIFY( button[4].AutoLoad(IDC_BUTTON5, this));
	VERIFY( button[5].AutoLoad(IDC_BUTTON6, this));
	VERIFY( button[6].AutoLoad(IDC_BUTTON7, this));
	VERIFY( button[7].AutoLoad(IDC_BUTTON8, this));
	VERIFY( button[8].AutoLoad(IDC_BUTTON9, this));

	return TRUE;  // return TRUE  unless you set the focus to a control
}


// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTictactoeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{   

		CRect rect;   
		GetClientRect(&rect);   
		CClientDC dc(this);   
		CPen mypen;
		mypen.CreatePen(PS_SOLID, 3, RGB(0, 0, 0));
		CPen* oldpen = dc.SelectObject(&mypen);   

		dc.MoveTo( 84, 12 );
		dc.LineTo( 84, 250 );

		dc.MoveTo( 155, 12 );
		dc.LineTo( 155, 250 );

		dc.MoveTo( 12, 90 );
		dc.LineTo( 222, 90 );

		dc.MoveTo( 12, 169 );
		dc.LineTo( 222, 169 );

		// end of added code

		dc.SelectObject(oldpen);

		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTictactoeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTictactoeDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	if ( buttonState[0] == 0 ) {
		VERIFY( button[0].LoadBitmaps(IDB_XU, IDB_XD, IDB_XF, IDB_XX ));
		buttonState[0] = 1;
		NewMove();
		SetFocus();
	}
}

void CTictactoeDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	if ( buttonState[1] == 0 ) {
		VERIFY( button[1].LoadBitmaps(IDB_XU, IDB_XD, IDB_XF, IDB_XX ));
		buttonState[1] = 1;
		NewMove();
		SetFocus();
	}
}

void CTictactoeDlg::OnButton3() 
{
	// TODO: Add your control notification handler code here
	if ( buttonState[2] == 0 ) {
		VERIFY( button[2].LoadBitmaps(IDB_XU, IDB_XD, IDB_XF, IDB_XX ));
		buttonState[2] = 1;
		NewMove();
		SetFocus();
	}
}

void CTictactoeDlg::OnButton4() 
{
	// TODO: Add your control notification handler code here
	if ( buttonState[3] == 0 ) {
		VERIFY( button[3].LoadBitmaps(IDB_XU, IDB_XD, IDB_XF, IDB_XX ));
		buttonState[3] = 1;
		NewMove();
		SetFocus();
	}
}

void CTictactoeDlg::OnButton5() 
{
	// TODO: Add your control notification handler code here
	if ( buttonState[4] == 0 ) {
		VERIFY( button[4].LoadBitmaps(IDB_XU, IDB_XD, IDB_XF, IDB_XX ));
		buttonState[4] = 1;
		NewMove();
		SetFocus();
	}
}

void CTictactoeDlg::OnButton6() 
{
	// TODO: Add your control notification handler code here
	if ( buttonState[5] == 0 ) {
		VERIFY( button[5].LoadBitmaps(IDB_XU, IDB_XD, IDB_XF, IDB_XX ));
		buttonState[5] = 1;
		NewMove();
		SetFocus();
	}
}

void CTictactoeDlg::OnButton7() 
{
	// TODO: Add your control notification handler code here
	if ( buttonState[6] == 0 ) {
		VERIFY( button[6].LoadBitmaps(IDB_XU, IDB_XD, IDB_XF, IDB_XX ));
		buttonState[6] = 1;
		NewMove();
		SetFocus();
	}
}

void CTictactoeDlg::OnButton8() 
{
	// TODO: Add your control notification handler code here
	if ( buttonState[7] == 0 ) {
		VERIFY( button[7].LoadBitmaps(IDB_XU, IDB_XD, IDB_XF, IDB_XX ));
		buttonState[7] = 1;
		NewMove();
		SetFocus();
	}
}

void CTictactoeDlg::OnButton9() 
{
	// TODO: Add your control notification handler code here
	if ( buttonState[8] == 0 ) {
		VERIFY( button[8].LoadBitmaps(IDB_XU, IDB_XD, IDB_XF, IDB_XX ));
		buttonState[8] = 1;
		NewMove();
		SetFocus();
	}
}

void CTictactoeDlg::OnNewgame() 
{
	// TODO: Add your control notification handler code here
 	// TODO: Add your control notification handler code here
    for ( int i = 0; i < 9; i++ ) {
 		buttonState[ i ] = 0;
 		VERIFY( button[i].LoadBitmaps(IDB_BU, IDB_BD, IDB_BF, IDB_BX ));
 	}
 	VERIFY( button[0].LoadBitmaps( IDB_OU, IDB_OD, IDB_OF, IDB_OX ));
 	buttonState[0] = 2;
	
}

void CTictactoeDlg::NewMove()
{	//  This Is Called for the Next Move

	if (((( buttonState[0] == 2 ) && ( buttonState[1] == 2 )) || 
		(( buttonState[6] == 2 ) && ( buttonState[4] == 2 )) ||
		(( buttonState[8] == 2 ) && ( buttonState[5] == 2 ))) &&
		( buttonState[ 2 ] == 0 )) {
		buttonState[2] = 2;
		VERIFY( button[2].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
		ResetMoves();	//  Have a Win
	} else if (((( buttonState[3] == 2 ) && ( buttonState[4] == 2 )) || 
		(( buttonState[2] == 2 ) && ( buttonState[8] == 2 ))) &&
		( buttonState[ 5 ] == 0 )) {
		buttonState[5] = 2;
		VERIFY( button[5].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
		ResetMoves();	//  Have a Win
	} else if (((( buttonState[0] == 2 ) && ( buttonState[4] == 2 )) || 
		(( buttonState[2] == 2 ) && ( buttonState[5] == 2 )) ||
		(( buttonState[6] == 2 ) && ( buttonState[7] == 2 ))) && 
		( buttonState[ 8 ] == 0 )) {
		buttonState[8] = 2;
		VERIFY( button[8].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
		ResetMoves();	//  Have a Win
	} else if (((( buttonState[0] == 2 ) && ( buttonState[2] == 2 )) || 
		(( buttonState[4] == 2 ) && ( buttonState[7] == 2 ))) && 
		( buttonState[ 1 ] == 0 )) {
		buttonState[1] = 2;
		VERIFY( button[1].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
		ResetMoves();	//  Have a Win
	} else if (((( buttonState[1] == 2 ) && ( buttonState[7] == 2 )) || 
		(( buttonState[3] == 2 ) && ( buttonState[5] == 2 )) ||
		(( buttonState[0] == 2 ) && ( buttonState[8] == 2 )) ||
		(( buttonState[2] == 2 ) && ( buttonState[6] == 2 ))) && 
		( buttonState[ 4 ] == 0 )) {
		buttonState[4] = 2;
		VERIFY( button[4].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
		ResetMoves();	//  Have a Win
	} else if (((( buttonState[1] == 2 ) && ( buttonState[4] == 2 )) || 
		(( buttonState[6] == 2 ) && ( buttonState[8] == 2 ))) &&
		( buttonState[ 2 ] == 0 )) {
		buttonState[7] = 2;
		VERIFY( button[7].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
		ResetMoves();	//  Have a Win
	} else if (((( buttonState[0] == 2 ) && ( buttonState[6] == 2 )) || 
		(( buttonState[4] == 2 ) && ( buttonState[5] == 2 ))) &&
		( buttonState[ 3 ] == 0 )) {
		buttonState[3] = 2;
		VERIFY( button[3].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
		ResetMoves();	//  Have a Win
	} else if (((( buttonState[0] == 2 ) && ( buttonState[3] == 2 )) || 
		(( buttonState[4] == 2 ) && ( buttonState[2] == 2 )) ||
		(( buttonState[7] == 2 ) && ( buttonState[8] == 2 ))) &&
		( buttonState[ 6 ] == 0 )) {
		buttonState[6] = 2;
		VERIFY( button[6].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
		ResetMoves();	//  Have a Win
	} else if ((( buttonState[4] == 1 ) && ( buttonState[7] == 1 )) &&
		( buttonState[ 1 ] == 0 )) {
		buttonState[1] = 2;
		VERIFY( button[1].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
	} else if (((( buttonState[6] == 1 ) && ( buttonState[4] == 1 )) || 
		(( buttonState[5] == 1 ) && ( buttonState[8] == 1 ))) && 
		( buttonState[ 2 ] == 0 )) {
		buttonState[2] = 2;
		VERIFY( button[2].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
	} else if ((( buttonState[4] == 1 ) && ( buttonState[5] == 1 )) &&
		( buttonState[ 3 ] == 0 )) {
		buttonState[3] = 2;
		VERIFY( button[3].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
	} else if (((( buttonState[1] == 1 ) && ( buttonState[7] == 2 )) || 
		(( buttonState[3] == 2 ) && ( buttonState[5] == 2 )) ||
		(( buttonState[6] == 2 ) && ( buttonState[2] == 2 ))) && 
		( buttonState[ 4 ] == 0 )) {
		buttonState[4] = 2;
		VERIFY( button[4].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
	} else if (((( buttonState[2] == 1 ) && ( buttonState[8] == 1 )) || 
		(( buttonState[3] == 1 ) && ( buttonState[4] == 1 ))) &&
		( buttonState[ 5 ] == 0 )) {
		buttonState[5] = 2;
		VERIFY( button[5].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
	} else if (((( buttonState[4] == 1 ) && ( buttonState[2] == 1 )) || 
		(( buttonState[7] == 1 ) && ( buttonState[8] == 1 ))) &&
		( buttonState[ 6 ] == 0 )) {
		buttonState[6] = 2;
		VERIFY( button[6].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
	} else if (((( buttonState[6] == 1 ) && ( buttonState[8] == 1 )) || 
		(( buttonState[1] == 1 ) && ( buttonState[4] == 1 ))) &&
		( buttonState[ 7 ] == 0 )) {
		buttonState[7] = 2;
		VERIFY( button[7].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
	} else if (((( buttonState[6] == 1 ) && ( buttonState[7] == 1 )) || 
		(( buttonState[2] == 1 ) && ( buttonState[5] == 1 ))) && 
		( buttonState[ 8 ] == 0 )) {
		buttonState[8] = 2;
		VERIFY( button[8].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
	} else if ( buttonState[ 8 ] == 0 ) {
		buttonState[8] = 2;
		VERIFY( button[8].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
	} else if ( buttonState[ 2 ] == 0 ) {
		buttonState[2] = 2;
		VERIFY( button[2].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
	} else if ( buttonState[ 6 ] == 0 ) {
		buttonState[6] = 2;
		VERIFY( button[6].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
	} else if ( buttonState[ 4 ] == 0 ) {
		buttonState[4] = 2;
		VERIFY( button[4].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
	} else if ( buttonState[ 1 ] == 0 ) {
		buttonState[1] = 2;
		VERIFY( button[1].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
	} else if ( buttonState[ 5 ] == 0 ) {
		buttonState[5] = 2;
		VERIFY( button[5].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
	} else if ( buttonState[ 3 ] == 0 ) {
		buttonState[3] = 2;
		VERIFY( button[3].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
	} else {
		buttonState[7] = 2;
		VERIFY( button[7].LoadBitmaps(IDB_OU, IDB_OD, IDB_OF, IDB_BX ));
	} 

}

void CTictactoeDlg::ResetMoves()
{

	for ( int i = 0; i < 9; i++ )
		if ( buttonState[ i ] == 0 ) {
			VERIFY( button[i].LoadBitmaps(IDB_IU, IDB_ID, IDB_IF, IDB_IX ));
			buttonState[ i ] = 3;
		}

}
