/*  PortTime - Time the Reads/Writes to LPT

   This is a Quick and Dirty Program to check how fast an I/O Port can
    be accessed.



    Myke Predko
    Started: 98.11.11
    Updated: xx.xx.xx

                                                                    */

//  Include Files
#include <stdio.h>
#include <dos.h>


//  Defines - Located in "global.var"
#define LPT1 0x0378             //  LPT1's Port Address
#define LPT2 0x0278

//  Subroutines


//  Global Variables


//  Mainline Code
main(argc, argv, envp)
   int argc;
   char *argv[];
   char *envp[];
{

int      BaseAddr;
long     Ctr = 0;               //  Counter Of the Number of I/Os
unsigned CurCtr;                //  Current Clock Value
unsigned far * ClkCtr;          //  Clock Counter


  if ( argc == 2 )              //  Port Specified?
    if ( strncmp( &argv[ 1 ], "1", 2 ) == 0 )
      BaseAddr = LPT1;          //  Set the Port Address
    else
      BaseAddr = LPT2;
  else
    BaseAddr = LPT1;            //  Default to LPT1

  (long) ClkCtr = 0x00040006C;  //  Get the Pointer to the Clock

  CurCtr = *ClkCtr;             //  Wait for an RTC Interrupt
  while ( CurCtr == *ClkCtr );

  CurCtr++;                     //  Increment

  while ( CurCtr == *ClkCtr ) {
    Ctr++;                      //  Count Number of I/Os in 55 msec
    outp( BaseAddr, inp( BaseAddr ));
  }  //  End while

  printf( "%lu Loops in 55 msec\n", Ctr );

}  //  End PortTime