//  BATY_N - Wait for the User To Input "Y" or "n"
//
//  This Program doesn't take any input parameters.
//
//  This program returns:
//   0x000 - If "Y" or "y" Entered
//   0x001 - If "N" or "n" Entered
//   0x0FF - For Anything Else
//
//  Myke Predko
//
//  98.10.31
//

//  Defines


//  Includes
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <asmprocs.h>


//  Global Variables


//  External Routines


//  Subroutines


//  Mainline
main(argc, argv, envp)          //  Define with the Input paramters
  int argc;
  char *argv[];
  char *envp;
{

union REGS regs;

  while ( GETKEYSTAT() != 0 )   //  Clear the Keyboard Buffer
    GETKEY();


  switch ( GETKEY() & 0x0FF )   //  Process the User Input
    {
      case 'Y':                 //  "Y"es
      case 'y':
        regs.h.al = 0;
        break;
      case 'N':                 //  "N"o
      case 'n':
        regs.h.al = 1;
        break;
      default:                  //  Everything Else
        regs.h.al = 0x0FF;
    } /*  endswitch  */

  regs.h.ah = 0x04C;            //  End with The ErrorLevel as the
  intdos( &regs, &regs );       //   Contents of the Register

}  //  End BATRead