PAGE ,132
TITLE FileName - File Description
;
;  FileName - File Description
;
;  This Program is assembled and linked into a .COM format executable.
;
;
;  Written By: Myke Predko
;
;
;  Version x.xx
;
;  Started: xx.xx.xx
;  Updated: xx.xx.xx
;
;
;  Conventions:
;  lower case - assembler mnemonics, macro names
;  Mixed Case - Variable Names, Program Labels, And Structures
;  UPPER CASE - CONSTANTS AND ASSEMBLER KEYWORDS
;
;  Chapters:
;  Chapter  1 - Header
;  Chapter  2 - Start
;  Chapter  3 - Structures
;  Chapter  4 - Macros
;  Chapter  5 - Constants
;  Chapter  6 - Mainline Code
;  Chapter  7 - Subroutines
;  Chapter  8 - Variables and Messages

PAGE +
 .model tiny
 .stack
 .code
ProgSeg SEGMENT WORD PUBLIC 'CODE'
        ASSUME  CS:ProgSeg, DS:ProgSeg, ES:ProgSeg, SS:ProgSeg
        ORG     100H
Start:

PAGE +
subtitle Program Structures
;
PtrFmt  STRUC                   ;  Format of a Pointer to Memory
PtrOff  dw      ?               ;  Offset to the Pointer
PtrSeg  dw      ?               ;  Segment of the Pointer
PtrFmt  ENDS

PAGE +
subtitle Program Macros
;
retfar  MACRO
        db      0CBh            ;  Return Far to Calling Program
        ENDM

PAGE +
subtitle Program Constants
;
DOSINT  = 21h                   ;  DOS Interrupt Vector
DOSPrt  = 09h                   ;  Print String Operation
DOSEnd  = 4Ch                   ;  Stop Execution
DOSSet  = 4Ah                   ;  Re-Allocate Memory

PAGE +
subtitle Mainline
Mainline PROC   NEAR
;

PAGE +
subtitle Subroutines
;

PAGE +
subtitle Program Variables and Messages
;

Mainline ENDP
ProgSeg ENDS
        END     Start           ;  End of Program
